// SimplexDoc.cpp : implementation of the CSimplexDoc class
//

#include "stdafx.h"
#include "Simplex.h"

#include "SimplexDoc.h"

#include <stdlib.h>
#include <malloc.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define ZERO 0

/////////////////////////////////////////////////////////////////////////////
// CSimplexDoc

IMPLEMENT_DYNCREATE(CSimplexDoc, CDocument)

BEGIN_MESSAGE_MAP(CSimplexDoc, CDocument)
	//{{AFX_MSG_MAP(CSimplexDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSimplexDoc construction/destruction

CSimplexDoc::CSimplexDoc()
{
	// TODO: add one-time construction code here
	created=false;
	achei_uma=false;

}

CSimplexDoc::~CSimplexDoc()
{
	if (created)
		LimpaMemoria();
}

BOOL CSimplexDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CSimplexDoc serialization

void CSimplexDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CSimplexDoc diagnostics

#ifdef _DEBUG
void CSimplexDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CSimplexDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSimplexDoc commands

void CSimplexDoc::LimpaMemoria()
{
	free(vetor_i);
	free(vetor_b);
	free(vetor_z1);
	free(vetor_z2);
	free(vetor_c1);
	free(vetor_c2);
	
	for (int index=0;index<num_restricoes;index++)
		free(matriz_a[index]);

	free(matriz_a);
	free(sinal_list);
	free(livres_list);

	created=false;
}

void CSimplexDoc::CriaMemoria()
{

	//vetores
	vetor_i=(int*)malloc(num_restricoes*sizeof(int));
	vetor_b=(vetor)malloc(num_restricoes*sizeof(float));
	vetor_z1=(vetor)malloc((num_variaveis+num_variaveis_livres+2*num_restricoes)*sizeof(float));
	vetor_z2=(vetor)malloc((num_variaveis+num_variaveis_livres+2*num_restricoes)*sizeof(float));
	vetor_c1=(vetor)malloc((num_variaveis+num_variaveis_livres+2*num_restricoes)*sizeof(float));
	vetor_c2=(vetor)malloc((num_variaveis+num_variaveis_livres+2*num_restricoes)*sizeof(float));
	//matriz
	matriz_a=(matriz)malloc(num_restricoes*sizeof(vetor));
	for (int index=0;index<num_restricoes;index++)
		matriz_a[index]=(vetor)malloc((num_variaveis+num_variaveis_livres+2*num_restricoes)*sizeof(float));
	//sinais
	sinal_list=(int *)malloc(sizeof(int)*num_restricoes);

	//livres
	livres_list=(int *)malloc(sizeof(int)*num_variaveis);

	count_livres=0;
}

void CSimplexDoc::SolveSystem(int mode)
{
	status=0;
	int index, index2,linha;
	bool tanabase,achou;
	int pivo_linha,pivo_coluna;
	float maior;

	//Fase 1 e 2 Juntas
	bool Termina=false;
	do
		{
		for (index=0;index<num_variaveis+num_variaveis_livres+num_artificiais+num_excesso;index++)
			{
			float soma1=0, soma2=0;
			for (int index2=0;index2<num_restricoes;index2++)
				{
				soma1+=vetor_z1[vetor_i[index2]]*matriz_a[index2][index];
				soma2+=vetor_z2[vetor_i[index2]]*matriz_a[index2][index];
				}
			vetor_c1[index]=vetor_z1[index]-soma1;
			vetor_c2[index]=vetor_z2[index]-soma2;
			soma1=soma2=0;
			}
		if(!Vetor_Nao_Negativo(vetor_c2,num_variaveis+num_variaveis_livres+num_artificiais+num_excesso))
			{
			//Achar o pivo

			if (!Acha_Pivo(vetor_c2,&pivo_linha,&pivo_coluna))
				{
				//Infinitas solues
				status=1;
				return;
				}
			
			//Faz o escalonamento da matriz
			for (int linha=0;linha<num_restricoes;linha++)			
				{
				if (pivo_linha!=linha)
					{
					float razao=matriz_a[linha][pivo_coluna]/matriz_a[pivo_linha][pivo_coluna];
					for (int coluna=0;coluna<num_variaveis+num_variaveis_livres+num_artificiais+num_excesso;coluna++)
						{
						if (pivo_coluna==coluna)
							matriz_a[linha][coluna]=0;
						else
							matriz_a[linha][coluna]=matriz_a[linha][coluna]-razao*matriz_a[pivo_linha][coluna];
						
						}
					vetor_b[linha]=vetor_b[linha]-razao*vetor_b[pivo_linha];
					}
				}
			
			float pivo=matriz_a[pivo_linha][pivo_coluna];
			
			for (int coluna=0;coluna<num_variaveis+num_variaveis_livres+num_artificiais+num_excesso;coluna++)
				matriz_a[pivo_linha][coluna]/=pivo;
			vetor_b[pivo_linha]/=pivo;
				
			
			//Muda a base
			vetor_i[pivo_linha]=pivo_coluna;
			}
		else
			{
			float soma=0;
			for (index=0;index<num_restricoes;index++)
				soma+=vetor_z2[vetor_i[index]]*vetor_b[index];
			if (soma!=0)
				{
				//Sem soluo
				status=2;
				return;
				}
			Termina=true;
			}

		} while(!Termina);	
		
	
	//Somente fase 2
	Termina=false;
	do
		{
		for (index=0;index<num_variaveis+num_variaveis_livres+num_excesso;index++)
			{
			float soma1=0;
			for (int index2=0;index2<num_restricoes;index2++)
				soma1+=vetor_z1[vetor_i[index2]]*matriz_a[index2][index];
				
			vetor_c1[index]=vetor_z1[index]-soma1;
			soma1=0;
			}
		if(!Vetor_Nao_Negativo(vetor_c1,num_variaveis+num_variaveis_livres+num_excesso))
			{
			//Achar o pivo

			if (!Acha_Pivo_F2(vetor_c1,&pivo_linha,&pivo_coluna))
				{
				//Infinitas solues
				status=1;
				return;
				}
			
			//Faz o escalonamento da matriz
			for (int linha=0;linha<num_restricoes;linha++)			
				{
				if (pivo_linha!=linha)
					{
					float razao=matriz_a[linha][pivo_coluna]/matriz_a[pivo_linha][pivo_coluna];
					for (int coluna=0;coluna<num_variaveis+num_variaveis_livres+num_artificiais+num_excesso;coluna++)
						{
						if (pivo_coluna==coluna)
							matriz_a[linha][coluna]=0;
						else
							matriz_a[linha][coluna]=matriz_a[linha][coluna]-razao*matriz_a[pivo_linha][coluna];
						
						}
					vetor_b[linha]=vetor_b[linha]-razao*vetor_b[pivo_linha];
					}
				}

			float pivo=matriz_a[pivo_linha][pivo_coluna];
			
			for (int coluna=0;coluna<num_variaveis+num_variaveis_livres+num_artificiais+num_excesso;coluna++)
				matriz_a[pivo_linha][coluna]/=pivo;
			vetor_b[pivo_linha]/=pivo;
				
			
			//Muda a base
			vetor_i[pivo_linha]=pivo_coluna;
			}
		else
			{
			//procura uma segunda resposta
			if (status!=3 && mode==0)
				{
				for (index=0;index<num_variaveis+num_variaveis_livres+num_excesso;index++)
					{
					if (vetor_c1[index]==0)
						{
						pivo_coluna=index;
						//Verifica se a variavel no est na base
						tanabase=false;
						for (index2=0;index2<num_restricoes;index2++)
							if (vetor_i[index2]==index)
								{
								tanabase=true;
								break;
								}
							
						if (!tanabase)
							{
							//Outra soluo
							status=3;
							first_vetor_b=vetor_b;
							first_vetor_i=vetor_i;
							vetor_b=(float *)malloc(sizeof(float)*num_restricoes);
							vetor_i=(int *)malloc(sizeof(int)*num_restricoes);
							for (index=0;index<num_restricoes;index++)
								{
								vetor_b[index]=first_vetor_b[index];
								vetor_i[index]=first_vetor_i[index];
								}
								
							achou=false;

							//Procura Linha do Pivo
							for (linha=0;linha<num_restricoes;linha++)
								{
								if ((vetor_b[linha]==0)&&(matriz_a[linha][pivo_coluna]!=0))
									{
									pivo_linha=linha;
									break;
									achou=true;
									}
								else
									if (matriz_a[linha][pivo_coluna]>0)
										if (((vetor_b[linha]/matriz_a[linha][pivo_coluna])<=maior)||!achou)
											{
											maior=vetor_b[linha]/matriz_a[linha][pivo_coluna];
											pivo_linha=linha;
											achou=true;
											}

								}
	
							if (!achou)
								{
								status=0;
								free(vetor_b);
								free(vetor_i);
								vetor_b=first_vetor_b;
								vetor_i=first_vetor_i;

								break;
								}
							//Pivoteia;
							vetor_i[pivo_linha]=pivo_coluna;
							//Faz o escalonamento da matriz
							for (int linha=0;linha<num_restricoes;linha++)			
								{
								if (pivo_linha!=linha)
									{
									float razao=matriz_a[linha][pivo_coluna]/matriz_a[pivo_linha][pivo_coluna];
									for (int coluna=0;coluna<num_variaveis+num_variaveis_livres+num_artificiais+num_excesso;coluna++)
										{
										if (pivo_coluna==coluna)
											matriz_a[linha][coluna]=0;
										else
											matriz_a[linha][coluna]=matriz_a[linha][coluna]-razao*matriz_a[pivo_linha][coluna];
						
										}
									vetor_b[linha]=vetor_b[linha]-razao*vetor_b[pivo_linha];
									}
								}

							float pivo=matriz_a[pivo_linha][pivo_coluna];
			
							for (int coluna=0;coluna<num_variaveis+num_variaveis_livres+num_artificiais+num_excesso;coluna++)
								matriz_a[pivo_linha][coluna]/=pivo;
							vetor_b[pivo_linha]/=pivo;
			
							}
						}
					if (!tanabase)
						break;
					}
				}
			Termina=true;
			}
			

		} while(!Termina);

Termina=false;
}

int CSimplexDoc::Vetor_Nao_Negativo(float *vet, int elementos)
{

	for(int index=0;index<elementos;index++)
		if (vet[index]<0) return 0;
	return 1;
}

int CSimplexDoc::Acha_Pivo(float *vet, int *pivo_l, int *pivo_c)
{

	int coluna, linha, coluna_r, linha_r;
	float menor=0, maior=0;
	bool achou=false;

	for (coluna=0;coluna<num_variaveis+num_variaveis_livres+num_excesso+num_artificiais;coluna++)
		{
		if (vet[coluna]<menor && vet[coluna]<0)
			{
			menor=vet[coluna];
			coluna_r=coluna;
			achou=true;
			}
		}

	if (!achou)
		return 0;
	
	achou=false;

	for (linha=0;linha<num_restricoes;linha++)
		{
		if ((vetor_b[linha]==0)&&(matriz_a[linha][coluna_r]>0))
			{
			linha_r=linha;
			break;
			achou=true;
			}
		else
			if (matriz_a[linha][coluna_r]>0)
				if (((vetor_b[linha]/matriz_a[linha][coluna_r])<=maior)||!achou)
					{
					maior=vetor_b[linha]/matriz_a[linha][coluna_r];
					linha_r=linha;
					achou=true;
					}

		}
	
	if (!achou)
		return 0;

	*pivo_l=linha_r;
	*pivo_c=coluna_r;
	return 1;

}

void CSimplexDoc::MontaTabela()
{
	int v_l;
	int index, index2;

	//Verificar Maximizar ou Minimizar
	if (otimizacao_maximizar)
		for (index=0;index<num_variaveis;index++)
			vetor_z1[index]=vetor_z1[index]*-1;

	//Verificar vetor b>0
	for (index=0;index<num_restricoes;index++)
		{
		if (vetor_b[index]<0)
			{
			vetor_b[index]=vetor_b[index]*-1;
			for (index2=0;index2<num_variaveis;index2++)
				matriz_a[index][index2]=matriz_a[index][index2]*-1;
			sinal_list[index]=4-sinal_list[index];
			}
		}
	
	//Verificar variveis livres
	v_l=0;
	if(num_variaveis_livres!=0)
	for (index=0;index<num_variaveis;index++)
		{
		if (livres_list[index]!=0)
			{
			for (index2=0;index2<num_restricoes;index2++)
				{
				matriz_a[index2][num_variaveis+v_l]=matriz_a[index2][index]*-1;
				}
			vetor_z1[num_variaveis+v_l]=vetor_z1[index]*-1;
			v_l++;
			}
		}

	//Verificar variveis excesso
	for (index=0;index<num_restricoes;index++)
		for (index2=0;index2<num_restricoes;index2++)
			matriz_a[index][num_variaveis+num_variaveis_livres+index2]=0;

	num_excesso=num_restricoes;
	v_l=0;

	for (index=0;index<num_restricoes;index++)
		{
		if (sinal_list[index]==0 || sinal_list[index]==1)
			{
			matriz_a[index][num_variaveis+num_variaveis_livres+v_l]=1;
			vetor_z1[num_variaveis+num_variaveis_livres+v_l]=0;
			v_l++;
			}
		else
			{
			if (sinal_list[index]==3 || sinal_list[index]==4)
				{
				matriz_a[index][num_variaveis+num_variaveis_livres+v_l]=-1;
				vetor_z1[num_variaveis+num_variaveis_livres+v_l]=0;
				v_l++;
				}
			else
				num_excesso--;
			}
		}
	
	//Colocar variveis artificiais
	num_artificiais=num_restricoes;
	v_l=0;

	for (index=0;index<2*num_restricoes+num_variaveis+num_variaveis_livres;index++)
		vetor_z2[index]=0;


	for (index=0;index<num_restricoes;index++)
		{
		if ((sinal_list[index]!=0)&&(sinal_list[index]!=1))
			{
			vetor_i[index]=(num_variaveis+num_variaveis_livres+num_excesso+v_l);
			vetor_z2[v_l+num_variaveis+num_variaveis_livres+num_excesso]=1;
			vetor_z1[v_l+num_variaveis+num_variaveis_livres+num_excesso]=0;

			for (index2=0;index2<num_restricoes;index2++)
				{
				if (vetor_i[index]==index2+num_variaveis+num_variaveis_livres+num_excesso)
					matriz_a[index][index2+num_variaveis+num_variaveis_livres+num_excesso]=1;
				else
					matriz_a[index][index2+num_variaveis+num_variaveis_livres+num_excesso]=0;
				}
			v_l++;
			}
		else
			{
			vetor_i[index]=num_variaveis+num_variaveis_livres+index;
			num_artificiais--;
			for (index2=0;index2<num_restricoes;index2++)
				matriz_a[index][index2+num_variaveis+num_variaveis_livres+num_excesso]=0;
			}
		}

}

int CSimplexDoc::Acha_Pivo_F2(float *vet, int *pivo_l, int *pivo_c)
{

	int coluna, linha, coluna_r, linha_r;
	float menor=0, maior=0;
	bool achou=false;

	for (coluna=0;coluna<num_variaveis+num_variaveis_livres+num_excesso;coluna++)
		{
		if (vet[coluna]<menor && vet[coluna]<0)
			{
			menor=vet[coluna];
			coluna_r=coluna;
			achou=true;
			}
		}

	if (!achou)
		return 0;
	
	achou=false;

	for (linha=0;linha<num_restricoes;linha++)
		{
		if ((vetor_b[linha]==0)&&(matriz_a[linha][coluna_r]>0))
			{
			linha_r=linha;
			achou=true;
			break;			
			}
		else
			if (matriz_a[linha][coluna_r]>0)
				if (((vetor_b[linha]/matriz_a[linha][coluna_r])<=maior)||!achou)
					{
					maior=vetor_b[linha]/matriz_a[linha][coluna_r];
					linha_r=linha;
					achou=true;
					}

		}
	
	if (!achou)
		return 0;

	*pivo_l=linha_r;
	*pivo_c=coluna_r;
	return 1;

}

void CSimplexDoc::CriaMemoriaEXP(int num_linhas, int num_colunas)
{

	int index2,index3;
	
	//Aloca os novos vetores
	new_vetor_z1=(float *)malloc(sizeof(float)*num_colunas);
	new_vetor_z2=(float *)malloc(sizeof(float)*num_colunas);
	new_vetor_c1=(float *)malloc(sizeof(float)*num_colunas);
	new_vetor_c2=(float *)malloc(sizeof(float)*num_colunas);
	new_vetor_b=(float *)malloc(sizeof(float)*num_linhas);
	new_vetor_i=(int *)malloc(sizeof(int)*num_linhas);

	new_matriz_a=(matriz)malloc(sizeof(vetor)*num_linhas);
	for (index2=0;index2<num_linhas;index2++)
		new_matriz_a[index2]=(vetor)malloc(sizeof(float)*num_colunas);

	//Copia os valores (Deslocando as variaveis artificiais)
	
	for (index3=0;index3<num_variaveis+num_excesso-1;index3++)
		{
		new_vetor_z1[index3]=vetor_z1_bkp[index3];
		new_vetor_z2[index3]=vetor_z2_bkp[index3];
		}
	for (index3=num_variaveis+num_excesso;index3<num_colunas;index3++)
		{
		new_vetor_z1[index3]=vetor_z1_bkp[index3-1];
		new_vetor_z2[index3]=vetor_z2_bkp[index3-1];
		}
							
	for (index3=0;index3<num_restricoes;index3++)
		{
		new_vetor_i[index3]=vetor_i_bkp[index3];
		new_vetor_b[index3]=vetor_b_bkp[index3];
		}
		
	for (index2=0;index2<num_variaveis+num_excesso-1;index2++)
		for (index3=0;index3<num_linhas-1;index3++)
			new_matriz_a[index3][index2]=matriz_a_bkp[index3][index2];

	for (index2=num_variaveis+num_excesso;index2<num_colunas;index2++)		
		for (index3=0;index3<num_linhas-1;index3++)
			new_matriz_a[index3][index2]=matriz_a_bkp[index3][index2-1];

	free(vetor_z1);
	free(vetor_z2);
	free(vetor_c1);
	free(vetor_c2);
	free(vetor_b);
	free(vetor_i);

	for (index2=0;index2<num_linhas-1;index2++)
		free(matriz_a[index2]);

	free(matriz_a);
							
	vetor_z1=new_vetor_z1;
	vetor_z2=new_vetor_z2;
	vetor_c1=new_vetor_c1;
	vetor_c2=new_vetor_c2;
	vetor_b=new_vetor_b;
	vetor_i=new_vetor_i;
	matriz_a=new_matriz_a;

}

void CSimplexDoc::CriaBackup()
{
///Cria e copia dos vetores e da matriz
	int index, index2;

	vetor_b_bkp=(float *)malloc(sizeof(float)*(num_variaveis+num_excesso+num_artificiais));
	vetor_i_bkp=(int *)malloc(sizeof(int)*num_restricoes);
	vetor_z1_bkp=(float *)malloc(sizeof(float)*(num_variaveis+num_excesso+num_artificiais));
	vetor_z2_bkp=(float *)malloc(sizeof(float)*(num_variaveis+num_excesso+num_artificiais));
	matriz_a_bkp=(float **)	malloc(sizeof(float)*num_restricoes);
	for (index=0;index<num_restricoes;index++)
		matriz_a_bkp[index]=(float *)malloc(sizeof(float)*(num_variaveis+num_excesso+num_artificiais));


	for (index=0;index<num_variaveis+num_excesso+num_artificiais;index++)
		{
		vetor_z1_bkp[index]=vetor_z1[index];
		vetor_z2_bkp[index]=vetor_z2[index];
		for (index2=0;index2<num_restricoes;index2++)
			matriz_a_bkp[index2][index]=matriz_a[index2][index];
		}
	
	for (index=0;index<num_restricoes;index++)
		{
		vetor_b_bkp[index]=vetor_b[index];
		vetor_i_bkp[index]=vetor_i[index];
		}
	
}

void CSimplexDoc::LimpaMemoriaEXP()
{
	int index;
		
	free(vetor_b_bkp);
	free(vetor_i_bkp);
	free(vetor_z1_bkp);
	free(vetor_z2_bkp);

	for (index=0;index<num_restricoes-1;index++)
		free(matriz_a_bkp[index]);

	free(matriz_a_bkp);
}

void CSimplexDoc::UsaBackup()
{

	int index,index2;
	
	for (index=0;index<num_restricoes;index++)
		{
		vetor_b[index]=vetor_b_bkp[index];
		vetor_i[index]=vetor_i_bkp[index];
		}
	for (index=0;index<num_variaveis+num_excesso+num_artificiais;index++)
		{
		vetor_z1[index]=vetor_z1_bkp[index];
		vetor_z2[index]=vetor_z2_bkp[index];
		for (index2=0;index2<num_restricoes;index2++)
			matriz_a[index2][index]=matriz_a_bkp[index2][index];
		}



}

void CSimplexDoc::CriaMemoriaIMP(int num_linhas, int num_colunas)
{
	int index2,index3;
	
	//Aloca os novos vetores
	new_vetor_z1=(float *)malloc(sizeof(float)*num_colunas);
	new_vetor_z2=(float *)malloc(sizeof(float)*num_colunas);
	new_vetor_c1=(float *)malloc(sizeof(float)*num_colunas);
	new_vetor_c2=(float *)malloc(sizeof(float)*num_colunas);
	new_vetor_b=(float *)malloc(sizeof(float)*num_linhas);
	new_vetor_i=(int *)malloc(sizeof(int)*num_linhas);

	new_matriz_a=(matriz)malloc(sizeof(vetor)*num_linhas);
	for (index2=0;index2<num_linhas;index2++)
		new_matriz_a[index2]=(vetor)malloc(sizeof(float)*num_colunas);

	//Copia os valores 
	for (index3=0;index3<num_variaveis+num_excesso+num_artificiais;index3++)
		{
		new_vetor_z1[index3]=vetor_z1_bkp[index3];
		new_vetor_z2[index3]=vetor_z2_bkp[index3];
		}
							
	for (index3=0;index3<num_restricoes;index3++)
		{
		new_vetor_i[index3]=vetor_i_bkp[index3];
		new_vetor_b[index3]=vetor_b_bkp[index3];
		}
		
	for (index2=0;index2<num_variaveis+num_excesso+num_artificiais;index2++)
		for (index3=0;index3<num_linhas;index3++)
			new_matriz_a[index3][index2]=matriz_a_bkp[index3][index2];

	
	free(vetor_z1);
	free(vetor_z2);
	free(vetor_c1);
	free(vetor_c2);
	free(vetor_b);
	free(vetor_i);

	for (index2=0;index2<num_linhas-1;index2++)
		free(matriz_a[index2]);

	free(matriz_a);
							
	vetor_z1=new_vetor_z1;
	vetor_z2=new_vetor_z2;
	vetor_c1=new_vetor_c1;
	vetor_c2=new_vetor_c2;
	vetor_b=new_vetor_b;
	vetor_i=new_vetor_i;
	matriz_a=new_matriz_a;

}

void CSimplexDoc::LimpaMemoriaIMP()
{
	LimpaMemoriaEXP();
}

void CSimplexDoc::CriaMemoriaDEC(int num_linhas, int num_colunas)
{
	int index2,index3;
	
	//Aloca os novos vetores
	new_vetor_z1=(float *)malloc(sizeof(float)*num_colunas);
	new_vetor_z2=(float *)malloc(sizeof(float)*num_colunas);
	new_vetor_c1=(float *)malloc(sizeof(float)*num_colunas);
	new_vetor_c2=(float *)malloc(sizeof(float)*num_colunas);
	new_vetor_b=(float *)malloc(sizeof(float)*num_linhas);
	new_vetor_i=(int *)malloc(sizeof(int)*num_linhas);

	new_matriz_a=(matriz)malloc(sizeof(vetor)*num_linhas);
	for (index2=0;index2<num_linhas;index2++)
		new_matriz_a[index2]=(vetor)malloc(sizeof(float)*num_colunas);

	//Copia os valores 
	//Exclui a ltima coluna excesso
	for (index3=0;index3<num_variaveis+num_excesso-1;index3++)
		{
		new_vetor_z1[index3]=vetor_z1_bkp[index3];
		new_vetor_z2[index3]=vetor_z2_bkp[index3];
		}
	
	//Exclui a ltima coluna artificial
	for (index3=num_variaveis+num_excesso;index3<num_variaveis+num_excesso+num_artificiais-1;index3++)
		{
		new_vetor_z1[index3-1]=vetor_z1_bkp[index3];
		new_vetor_z2[index3-1]=vetor_z2_bkp[index3];
		}
							
	for (index3=0;index3<num_linhas;index3++)
		{
		new_vetor_i[index3]=vetor_i_bkp[index3];
		new_vetor_b[index3]=vetor_b_bkp[index3];
		}
		
	for (index2=0;index2<num_variaveis+num_excesso-1;index2++)
		for (index3=0;index3<num_linhas;index3++)
			new_matriz_a[index3][index2]=matriz_a_bkp[index3][index2];

	for (index2=num_variaveis+num_excesso;index2<num_variaveis+num_excesso+num_artificiais-1;index2++)
		for (index3=0;index3<num_linhas;index3++)
			new_matriz_a[index3][index2-1]=matriz_a_bkp[index3][index2];

	
	free(vetor_z1);
	free(vetor_z2);
	free(vetor_c1);
	free(vetor_c2);
	free(vetor_b);
	free(vetor_i);

	for (index2=0;index2<num_linhas-1;index2++)
		free(matriz_a[index2]);

	free(matriz_a);
							
	vetor_z1=new_vetor_z1;
	vetor_z2=new_vetor_z2;
	vetor_c1=new_vetor_c1;
	vetor_c2=new_vetor_c2;
	vetor_b=new_vetor_b;
	vetor_i=new_vetor_i;
	matriz_a=new_matriz_a;

}

void CSimplexDoc::CriaMemoriaGomory()
{
	int index, index2;

	//Cria o espao necessrio
	new_vetor_b=(float *)malloc(sizeof(float)*(num_restricoes+1));
	new_vetor_i=(int *)malloc(sizeof(int *)*(num_restricoes+1));
	new_vetor_z1=(float *)malloc(sizeof(float)*(num_variaveis+num_excesso+num_artificiais+2));
	new_vetor_z2=(float *)malloc(sizeof(float)*(num_variaveis+num_excesso+num_artificiais+2));
	new_vetor_c1=(float *)malloc(sizeof(float)*(num_variaveis+num_excesso+num_artificiais+2));
	new_vetor_c2=(float *)malloc(sizeof(float)*(num_variaveis+num_excesso+num_artificiais+2));
			
	//e Matriz_a...
	new_matriz_a=(float **)malloc(sizeof(float *)*(num_restricoes+1));
	for (index=0;index<num_restricoes+1;index++)
		new_matriz_a[index]=(float *)malloc(sizeof(float)*(num_variaveis+num_excesso+num_artificiais+2));

	//Copia os valores do problema 
	for (index=0;index<num_variaveis+num_excesso;index++) {
		new_vetor_z1[index]=vetor_z1[index];
		new_vetor_z2[index]=vetor_z2[index];
		
		for (index2=0;index2<num_restricoes;index2++)
			new_matriz_a[index2][index]=matriz_a[index2][index];
	}
	
	for (index=0;index<num_restricoes;index++) {
		new_vetor_b[index]=vetor_b[index];
		new_vetor_i[index]=vetor_i[index];
	}
	
	new_vetor_z1[num_variaveis+num_excesso]=0;
	new_vetor_z2[num_variaveis+num_excesso]=0;
	for (index=0;index<num_restricoes;index++)
		new_matriz_a[index][num_variaveis+num_excesso]=0;

	for (index=num_variaveis+num_excesso;index<num_variaveis+num_excesso+num_artificiais;index++) {
		new_vetor_z1[index+1]=vetor_z1[index];
		new_vetor_z2[index+1]=vetor_z2[index];
		for (index2=0;index2<num_restricoes;index2++)
			new_matriz_a[index2][index+1]=matriz_a[index2][index];
	}

	new_vetor_z1[num_variaveis+num_excesso+num_artificiais+1]=0;
	new_vetor_z2[num_variaveis+num_excesso+num_artificiais+1]=1;

	for (index=0;index<num_restricoes;index++)
		new_matriz_a[index][num_variaveis+num_excesso+num_artificiais+1]=0;

	for (index=0;index<num_variaveis+num_excesso+num_artificiais;index++)
		new_matriz_a[num_restricoes][index]=0;

	//Substitui o sistema novo pelo original
	free(vetor_b);
	free(vetor_i);
	free(vetor_z1);
	free(vetor_z2);
	free(vetor_c1);
	free(vetor_c2);

	for (index=0;index<num_restricoes;index++)
		free(matriz_a[index]);

	free(matriz_a);

	vetor_b=new_vetor_b;
	vetor_i=new_vetor_i;
	vetor_z1=new_vetor_z1;
	vetor_z2=new_vetor_z2;
	vetor_c1=new_vetor_c1;
	vetor_c2=new_vetor_c2;
	matriz_a=new_matriz_a;

	//Atualiza a quantidade de variveis e restries
	num_excesso+=1;
	num_artificiais+=1;
	num_restricoes+=1;

}
