// SimplexView.cpp : implementation of the CSimplexView class
//

#include "stdafx.h"
#include "Simplex.h"

#include "StartDialog.h"
#include "SimplexDoc.h"
#include "SimplexView.h"

#include <stdlib.h>
#include <malloc.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include <math.h>

#define ERRO 1e-4
#define MAX_ITE 100

/////////////////////////////////////////////////////////////////////////////
// CSimplexView

IMPLEMENT_DYNCREATE(CSimplexView, CScrollView)

BEGIN_MESSAGE_MAP(CSimplexView, CScrollView)
	//{{AFX_MSG_MAP(CSimplexView)
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	ON_COMMAND(ID_FILE_SOLVE, OnFileSolve)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSimplexView construction/destruction

CSimplexView::CSimplexView()
{
	// TODO: add construction code here
	celulas=NULL;
	labels=NULL;
}

CSimplexView::~CSimplexView()
{
}

BOOL CSimplexView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CScrollView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CSimplexView drawing

void CSimplexView::OnDraw(CDC* pDC)
{
	CSimplexDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here

}

void CSimplexView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();
	CSize sizeTotal;
	// TODO: calculate the total size of this view
	sizeTotal.cx = sizeTotal.cy = 100;
	SetScrollSizes(MM_TEXT, sizeTotal);
	
}

/////////////////////////////////////////////////////////////////////////////
// CSimplexView diagnostics

#ifdef _DEBUG
void CSimplexView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CSimplexView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CSimplexDoc* CSimplexView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSimplexDoc)));
	return (CSimplexDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSimplexView message handlers

void CSimplexView::OnFileNew() 
{
	// TODO: Add your command handler code here
	CSimplexDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	
	if (pDoc->created)
		{
		if (MessageBox("Todos os dados sero perdidos! Voc deseja continuar?", "Ateno", MB_OKCANCEL)==IDCANCEL)
			return;
		pDoc->LimpaMemoria();
		for (int index=0;index<(pDoc->num_variaveis*(pDoc->num_restricoes+1)+pDoc->num_restricoes);index++)
			if (celulas[index])
				delete celulas[index];
		free(celulas);
		
		for (index=0;index<(pDoc->num_variaveis+5);index++)
			if (labels[index])
				delete labels[index];
		free(labels);

		for (index=0;index<(pDoc->num_restricoes);index++)
			if (sinais[index])
				delete sinais[index];
		free(sinais);

		for (index=0;index<(pDoc->num_variaveis);index++)
			if (livre[index])
				delete livre[index];
		free(livre);
		}

	CStartDialog dlg;
	int resultado=dlg.DoModal();
	
	if (resultado==IDOK)
		{
		//Ok;
		if (dlg.m_integer==0 || dlg.m_int_bl==0)
			{
			pDoc->programacao_inteira=true;
			if (dlg.m_int_bl==0)
				pDoc->int_type=true;//Bifurcao e Limite
			else
				pDoc->int_type=false;//Gomory;
			}
		else
			pDoc->programacao_inteira=false;

		if (dlg.m_max==0)
			pDoc->otimizacao_maximizar=true;
		else
			pDoc->otimizacao_maximizar=false;
		
		pDoc->num_variaveis=dlg.m_variaveis;
		pDoc->num_restricoes=dlg.m_restricoes;
		pDoc->num_variaveis_livres=dlg.m_livres;

		if (pDoc->num_variaveis_livres>pDoc->num_variaveis)
			{
			MessageBox("Nmero de variveis livres invlido.","Simplex");
			return;
			}
		
		pDoc->CriaMemoria();
		pDoc->created=true;
		
		celulas=(CCelula**)malloc(sizeof(CCelula*)*(dlg.m_variaveis*(dlg.m_restricoes+1)+dlg.m_restricoes));
		for (int index=0;index<(dlg.m_variaveis*(dlg.m_restricoes+1)+dlg.m_restricoes);index++)
			celulas[index]=NULL;
		labels=(CLabels**)malloc(sizeof(CLabels*)*(dlg.m_variaveis+5));
		for (index=0;index<(dlg.m_variaveis+4);index++)
			labels[index]=NULL;

		sinais=(CSinal**)malloc(sizeof(CSinal*)*dlg.m_restricoes);
		for (index=0;index<dlg.m_restricoes;index++)
			sinais[index]=NULL;
		livre=(CCheck**)malloc(sizeof(CCheck*)*dlg.m_variaveis);
		for (index=0;index<dlg.m_variaveis;index++)
			livre[index]=NULL;

		MontaTela();
		if (pDoc->programacao_inteira && pDoc->num_variaveis_livres)
			{
			MessageBox("No  possvel utilizar variveis livres.","Simplex");
			pDoc->num_variaveis_livres=0;
			}

		}	
}

void CSimplexView::MontaTela()
{
	CString lbl;
	char buffer[20];
	RECT rect={100,0,199,24};
		
	CSimplexDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

//Create( LPCTSTR lpszText, DWORD dwStyle, const RECT& rect, 
//CWnd* pParentWnd, UINT nID = 0xffff );
	
	for (int index=0;index<pDoc->num_variaveis;index++)
		{
		lbl="x";
		labels[index]=new CLabels;
		labels[index]->Create(lbl+_itoa(index,buffer,10),SS_CENTER | WS_CHILD | WS_VISIBLE,rect,this,0xffff);
		labels[index]->ShowWindow(SW_SHOW);
		rect.left+=100;
		rect.right+=100;
		}
		
		lbl="= > <";
		labels[pDoc->num_variaveis]=new CLabels;
		labels[pDoc->num_variaveis]->Create(lbl,SS_CENTER | WS_CHILD | WS_VISIBLE,rect,this,0xffff);
		labels[pDoc->num_variaveis]->ShowWindow(SW_SHOW);

		rect.left+=100;
		rect.right+=100;
		
		lbl="b";
		labels[pDoc->num_variaveis+1]=new CLabels;
		labels[pDoc->num_variaveis+1]->Create(lbl,SS_CENTER | WS_CHILD | WS_VISIBLE,rect,this,0xffff);
		labels[pDoc->num_variaveis+1]->ShowWindow(SW_SHOW);
		
		rect.top=25;
		rect.left=0;
		rect.bottom=49;
		rect.right=99;

		lbl="Z=";
		labels[pDoc->num_variaveis+2]=new CLabels;
		labels[pDoc->num_variaveis+2]->Create(lbl,SS_CENTER | WS_CHILD | WS_VISIBLE,rect,this,0xffff);
		labels[pDoc->num_variaveis+2]->ShowWindow(SW_SHOW);


//BOOL Create( DWORD dwStyle, const RECT& rect, 
//CWnd* pParentWnd, UINT nID );
		for (index=0;index<pDoc->num_variaveis;index++)
			{
			rect.left+=100;
			rect.right+=100;
			celulas[index]= new CCelula(index,0,&(pDoc->vetor_z1));
			celulas[index]->Create(ES_RIGHT | WS_CHILD | WS_VISIBLE | WS_BORDER,rect,this,0xffff);
			celulas[index]->ShowWindow(SW_SHOW);
			}

		rect.top=50;
		rect.left=0;
		rect.bottom=74;
		rect.right=99;

		lbl="Estado";
		labels[pDoc->num_variaveis+3]=new CLabels;
		labels[pDoc->num_variaveis+3]->Create(lbl,SS_CENTER | WS_CHILD | WS_VISIBLE,rect,this,0xffff);
		labels[pDoc->num_variaveis+3]->ShowWindow(SW_SHOW);

//BOOL Create( LPCTSTR lpszCaption, DWORD dwStyle, 
//const RECT& rect, CWnd* pParentWnd, UINT nID );		
		
		for (index=0;index<pDoc->num_variaveis;index++)
			{
			rect.left+=100;
			rect.right+=100;
			livre[index]= new CCheck(index,&(pDoc->count_livres),pDoc->num_variaveis_livres);
			livre[index]->Create("Livre",BS_AUTOCHECKBOX | WS_CHILD | WS_VISIBLE,rect,this,NULL);
			livre[index]->ShowWindow(SW_SHOW);
			}

		
		rect.top=75;
		rect.left=0;
		rect.bottom=99;
		rect.right=99;

		lbl="s.a.";
		labels[pDoc->num_variaveis+4]=new CLabels;
		labels[pDoc->num_variaveis+4]->Create(lbl,SS_CENTER | WS_CHILD | WS_VISIBLE,rect,this,0xffff);
		labels[pDoc->num_variaveis+4]->ShowWindow(SW_SHOW);

		int index2=0;
		int count=pDoc->num_variaveis;

		for (index=0;index<pDoc->num_variaveis;index++)
			{
			rect.left=100+index*100;
			rect.right=199+index*100;
			for (index2=0;index2<pDoc->num_restricoes;index2++)
				{
				rect.top=75+index2*25;
				rect.bottom=99+index2*25;
				celulas[count]= new CCelula(index,index2,pDoc->matriz_a);
				celulas[count]->Create(ES_RIGHT | WS_CHILD | WS_VISIBLE | WS_BORDER,rect,this,0xffff);
				celulas[count]->ShowWindow(SW_SHOW);
				count++;
				}
			}
		
		rect.left=100*(pDoc->num_variaveis+2);
		rect.right=rect.left+99;

		for (index=0;index<pDoc->num_restricoes;index++)
			{
			rect.top=75+index*25;
			rect.bottom=rect.top+24;
			celulas[count]= new CCelula(index,0,&(pDoc->vetor_b));
			celulas[count]->Create(ES_RIGHT | WS_CHILD | WS_VISIBLE | WS_BORDER,rect,this,0xffff);
			celulas[count]->ShowWindow(SW_SHOW);
			count++;
			}

//BOOL Create( DWORD dwStyle, const RECT& rect, 
//CWnd* pParentWnd, UINT nID );

		rect.left=100*(pDoc->num_variaveis+1);
		rect.right=rect.left+99;
		
		for (index=0;index<pDoc->num_restricoes;index++)
			{
			rect.top=75+index*25;
			rect.bottom=rect.top+24;
			sinais[index]=new CSinal;
			sinais[index]->Create(LBS_STANDARD | WS_CHILD | WS_VISIBLE | WS_BORDER,rect,this,NULL);
			sinais[index]->AddString("=");
			sinais[index]->AddString(">");
			sinais[index]->AddString("<");
			sinais[index]->AddString(">=");
			sinais[index]->AddString("<=");
			sinais[index]->ShowWindow(SW_SHOW);
			}
		
		SIZE size;

		size.cx=(pDoc->num_variaveis+3)*100;
		size.cy=(pDoc->num_restricoes+3)*25;
		SetScrollSizes(MM_TEXT,size,sizeDefault,sizeDefault);

}

void CSimplexView::OnFileSolve() 
{
	// TODO: Add your command handler code here
	
	int original_excesso, original_restricoes, original_variaveis;
	int valor,var_value, limpa;
	int index, index2;
	bool respostas_inteiras, volta_no;
	float max_z=0, aux_max_z;
	unsigned char pilha[255]; //at 255
	int pilha_count=0;
	bool achei_uma=false;
	double frac, inteira;
	CSimplexDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	
	if (!pDoc->created){
		MessageBox("Nada para resolver.","Simplex");
		return;
	}
	
	for (index=0;index<pDoc->num_restricoes;index++)
		if (sinais[index]->GetCurSel()<0) {
			MessageBox("Defina os sinais das restries","Simplex");
			return;
		} else
			pDoc->sinal_list[index]=sinais[index]->GetCurSel();		
		
	if (pDoc->num_variaveis_livres!=pDoc->count_livres){
		MessageBox("Defina todas as variveis livres","Simplex");
		return;
	}
	
	for (index=0;index<pDoc->num_variaveis;index++)
		pDoc->livres_list[index]=livre[index]->GetState()&0x0003;


	for (index=0;index<(pDoc->num_variaveis*(pDoc->num_restricoes+1)+pDoc->num_restricoes);index++)
		celulas[index]->Atualiza();
		
	//Monta a tabela e os vetores iniciais;
	pDoc->MontaTabela();
	original_excesso=pDoc->num_excesso;
	limpa=original_restricoes=pDoc->num_restricoes;
	original_variaveis=pDoc->num_variaveis;
		
	//Seleciona o tipo de problema;
	if (!pDoc->programacao_inteira){
		pDoc->SolveSystem(0);
		CDialogResult dlg(NULL,pDoc);			
		dlg.DoModal();	
	} else {
		if (pDoc->int_type) {
			//Bifurcao e Limite
			//Avalia a resposta
			//Verificar se as variveis do problema inteiras
			pDoc->CriaBackup();		//Backup
			do {
				respostas_inteiras=true;
				volta_no=false;
				pDoc->SolveSystem(1); //Acha uma nica resposta
				if (pDoc->status!=0 && pilha_count==0 && pilha[pilha_count]==0) //Sem soluo
					break;
				else
					if (pDoc->status!=0)
						volta_no=true;
					else {
						//Verifica se j achou resposta inteira
						//Se sim calcula o valor do vetor
						//Se menor para
						if (achei_uma) {
							aux_max_z=0;
							for (index=0;index<pDoc->num_restricoes;index++)
								if (pDoc->vetor_i[index]<pDoc->num_variaveis)
									aux_max_z+=pDoc->vetor_z1[pDoc->vetor_i[index]]*pDoc->vetor_b[index];
							
							if (aux_max_z>max_z) {
								//volta o n
								volta_no=true;
								respostas_inteiras=false;
							}
						}		
						
						if (!volta_no) {
							//Encontra qual variavel no est inteira
							for (index=0;index<pDoc->num_restricoes;index++) {
								if (pDoc->vetor_i[index]<pDoc->num_variaveis) {
									//Varivel original do problema
									frac=modf(pDoc->vetor_b[index],&inteira);
									frac+=ERRO;
									if (frac>=1 || frac<ERRO*10) {
										//J possui valor inteiro
										//Vai para a prxima
										continue;
									} else {
										var_value=pDoc->vetor_i[index];
										valor=(int)pDoc->vetor_b[index];
										pilha[pilha_count]=0;
										pilha_count++;
										pDoc->num_restricoes++;
										pDoc->num_excesso++;
										pDoc->CriaMemoriaEXP(pDoc->num_restricoes,pDoc->num_variaveis+pDoc->num_excesso+pDoc->num_artificiais);
										pDoc->LimpaMemoriaEXP();
										//Coloca os valores da restrio
										for (index2=0;index2<pDoc->num_variaveis+pDoc->num_excesso+pDoc->num_artificiais;index2++)
											pDoc->matriz_a[pDoc->num_restricoes-1][index2]=0;
										for (index2=0;index2<pDoc->num_restricoes;index2++)
											pDoc->matriz_a[index2][pDoc->num_variaveis+pDoc->num_excesso-1]=0;

										//Corrige o vetor de ndices
										for (index2=0;index2<pDoc->num_restricoes;index2++)
											if (pDoc->vetor_i[index2]>=pDoc->num_variaveis+pDoc->num_excesso-1)
												pDoc->vetor_i[index2]+=1;
										pDoc->matriz_a[pDoc->num_restricoes-1][var_value]=1;
 										pDoc->matriz_a[pDoc->num_restricoes-1][pDoc->num_variaveis+pDoc->num_excesso-1]=1;
										pDoc->vetor_i[pDoc->num_restricoes-1]=pDoc->num_variaveis+pDoc->num_excesso-1;
										pDoc->vetor_z1[pDoc->num_variaveis+pDoc->num_excesso-1]=0;
										pDoc->vetor_z2[pDoc->num_variaveis+pDoc->num_excesso-1]=0;
										pDoc->vetor_b[pDoc->num_restricoes-1]=(float)valor;
										pDoc->CriaBackup();
										respostas_inteiras=false;
										break;
									}//Fim do else da verificao v.i
								} else //fim do if volta n
									continue;
							}
						}//Fim do if
				
					
						if (respostas_inteiras) {
							//Encontrou uma soluo inteira
							//Calcula o valor de Z;
							aux_max_z=0;
							for (index=0;index<pDoc->num_restricoes;index++)
								if (pDoc->vetor_i[index]<pDoc->num_variaveis)
									aux_max_z+=pDoc->vetor_z1[pDoc->vetor_i[index]]*pDoc->vetor_b[index];
					
							//Verifica se no acho a resposta logo no primeiro quadro
							if (pilha_count==0 && pilha[pilha_count]==0)
								break;
							else {
								//Verifica se  o maior Z
								//Se for salva a resposta
								if (aux_max_z<max_z || !achei_uma){
									if (achei_uma){
										free(pDoc->first_vetor_i);
										free(pDoc->first_vetor_b);
									}
									max_z=aux_max_z;
									pDoc->first_num_restricoes=pDoc->num_restricoes;
									pDoc->first_vetor_i=pDoc->vetor_i;
									pDoc->first_vetor_b=pDoc->vetor_b;
									pDoc->vetor_i=(int *)malloc(sizeof(int)*pDoc->num_restricoes);
									pDoc->vetor_b=(float *)malloc(sizeof(float)*pDoc->num_restricoes);
									achei_uma=true;
								}
							}
							volta_no=true;
						}
					}
				
				if (volta_no)
					if (pilha[pilha_count-1]==0) {
						//Voltando um n
						pilha[pilha_count-1]=1;
						//Altera a tabela
						pDoc->UsaBackup(); //Copia ltima tabela
						pDoc->matriz_a_bkp[pDoc->num_restricoes-1][pDoc->num_variaveis+pDoc->num_excesso-1]=-1;
						//Adiciona + 1 artificial
						pDoc->CriaMemoriaIMP(pDoc->num_restricoes,pDoc->num_variaveis+pDoc->num_excesso+pDoc->num_artificiais+1);
						pDoc->LimpaMemoriaIMP(); 
						//Completa com os valores corretos
						pDoc->vetor_z1[pDoc->num_variaveis+pDoc->num_excesso+pDoc->num_artificiais]=0;
						pDoc->vetor_z2[pDoc->num_variaveis+pDoc->num_excesso+pDoc->num_artificiais]=1;
						pDoc->vetor_b[pDoc->num_restricoes-1]+=1;//novo limite
						pDoc->vetor_i[pDoc->num_restricoes-1]=pDoc->num_variaveis+pDoc->num_excesso+pDoc->num_artificiais;
						//e matriz
						for (index=0;index<pDoc->num_restricoes;index++)
							pDoc->matriz_a[index][pDoc->num_variaveis+pDoc->num_artificiais+pDoc->num_excesso]=0;
						
						pDoc->matriz_a[pDoc->num_restricoes-1][pDoc->num_variaveis+pDoc->num_excesso+pDoc->num_artificiais]=1;
						pDoc->num_artificiais++; //atualiza o valor de artificiais
						pDoc->CriaBackup();
						respostas_inteiras=false;
					} else {
						while (pilha[pilha_count-1]==1) {
							pilha_count--;
							//Remove ltima linha, ltima coluna artificial e ltima coluna excesso
							//e ltima linha
							pDoc->CriaMemoriaDEC(pDoc->num_restricoes-1,pDoc->num_variaveis+pDoc->num_excesso+pDoc->num_artificiais-2);
							
							for (index2=0;index2<pDoc->num_restricoes-1;index2++)
								if (pDoc->vetor_i[index2]>=pDoc->num_variaveis+pDoc->num_excesso)
									pDoc->vetor_i[index2]-=1;

							pDoc->num_excesso-=1;
							pDoc->num_restricoes-=1;
							pDoc->num_artificiais-=1;
							pDoc->CriaBackup();
						}
								
							
						pilha[pilha_count-1]=1;
						//Altera a tabela
						pDoc->matriz_a_bkp[pDoc->num_restricoes-1][pDoc->num_variaveis+pDoc->num_excesso-1]=-1;
						//Adiciona + 1 artificial
						pDoc->CriaMemoriaIMP(pDoc->num_restricoes,pDoc->num_variaveis+pDoc->num_excesso+pDoc->num_artificiais+1);
						pDoc->LimpaMemoriaIMP(); 
						//Completa com os valores corretos
						pDoc->vetor_z1[pDoc->num_variaveis+pDoc->num_excesso+pDoc->num_artificiais]=0;
						pDoc->vetor_z2[pDoc->num_variaveis+pDoc->num_excesso+pDoc->num_artificiais]=1;
						pDoc->vetor_b[pDoc->num_restricoes-1]+=1;//novo limite
						pDoc->vetor_i[pDoc->num_restricoes-1]=pDoc->num_variaveis+pDoc->num_excesso+pDoc->num_artificiais;
						//e matriz
						for (index=0;index<pDoc->num_restricoes;index++)
							pDoc->matriz_a[index][pDoc->num_variaveis+pDoc->num_artificiais+pDoc->num_excesso]=0;
													
						pDoc->matriz_a[pDoc->num_restricoes-1][pDoc->num_variaveis+pDoc->num_excesso+pDoc->num_artificiais]=1;
						pDoc->num_artificiais++; //atualiza o valor de artificiais
						pDoc->CriaBackup();
						respostas_inteiras=false;
					}
			} while (!achei_uma || pilha_count!=0 || pilha[pilha_count]!=1);

			pDoc->LimpaMemoriaEXP();
		} else {
			//Gomory
			Gomory(pDoc);
		}
			
		

		limpa=pDoc->num_restricoes;
		if (pDoc->programacao_inteira) {
			if (pDoc->int_type)
				if (achei_uma) {
					free(pDoc->vetor_b);
					free(pDoc->vetor_i);
					pDoc->num_restricoes=pDoc->first_num_restricoes;
					pDoc->vetor_b=pDoc->first_vetor_b;
					pDoc->vetor_i=pDoc->first_vetor_i;
					achei_uma=false;
					pDoc->status=0;
				}
		
			for (index=0;index<pDoc->num_restricoes;index++) {
				frac=modf(pDoc->vetor_b[index],&inteira);
				pDoc->vetor_b[index]=(float)inteira;
			}	
			CDialogResult dlg(NULL,pDoc);
			dlg.DoModal();
		}
	}
	//Aloca memria suficiente para Reiniciar o problema
	free(pDoc->vetor_b);
	free(pDoc->vetor_i);
	free(pDoc->vetor_z1);
	free(pDoc->vetor_z2);
	free(pDoc->vetor_c1);
	free(pDoc->vetor_c2);
	for (index=0;index<limpa;index++)
		free(pDoc->matriz_a[index]);
	free(pDoc->matriz_a);
	pDoc->num_excesso=original_excesso;
	pDoc->num_restricoes=original_restricoes;
	pDoc->num_variaveis=original_variaveis;

	pDoc->CriaMemoria();

	for (index=0;index<pDoc->num_variaveis;index++)
		celulas[index]->destino=&pDoc->vetor_z1;
	for (index=0;index<pDoc->num_variaveis*pDoc->num_restricoes;index++)
		celulas[index+pDoc->num_variaveis]->destino=pDoc->matriz_a;
	for (index=0;index<pDoc->num_restricoes;index++)
		celulas[index+(pDoc->num_variaveis*pDoc->num_restricoes)+pDoc->num_variaveis]->destino=&pDoc->vetor_b;
			
}

void CSimplexView::Gomory(CSimplexDoc * pDoc)
{
	bool respostas_inteiras;
	int count=0, index, linha;
	double frac, inteira;

	do {
		respostas_inteiras=true;
		
		//resolve o problema
		pDoc->SolveSystem(1);
		
		//verifica erro
		if (pDoc->status!=0)
			break;

		//verifica se as respostas esto inteiras
		for (index=0;index<pDoc->num_restricoes;index++) {
			if (pDoc->vetor_i[index]<pDoc->num_variaveis) {
			//varivel pertence ao problema original
				frac=modf(pDoc->vetor_b[index],&inteira);
				if ((frac+ERRO)>=1 || (frac+ERRO)<ERRO*10) {
					//Varivel  inteira
					continue;
				} else {
					linha=index;
					respostas_inteiras=false;
					break;
				}
			}
		}
		
		//Caso ainda exista respostas no inteiras, calcula expresso
		//auxiliar e adiciona ao problema
		if (!respostas_inteiras) {
			float *indices;
		
			//Calcula os ndices para a nova restrio
			indices=(float *)malloc(sizeof(float)*(pDoc->num_variaveis+pDoc->num_excesso+pDoc->num_artificiais));
			for (index=0;index<pDoc->num_variaveis+pDoc->num_excesso+pDoc->num_artificiais;index++)
				indices[index]=0;
			for (index=0;index<pDoc->num_variaveis+pDoc->num_excesso+pDoc->num_artificiais;index++) {
				frac=modf(pDoc->matriz_a[linha][index],&inteira);
				if (frac<0)
					frac+=1;
				indices[index]=(float)frac;
			}

			//Aloca espao para o novo problema
			//acrscimo de varivel de excesso, artificial e restrio
			pDoc->CriaMemoriaGomory();
			//Adiciona a ltima restrio
			for (index=0;index<pDoc->num_variaveis+pDoc->num_excesso+pDoc->num_artificiais;index++)
				pDoc->matriz_a[pDoc->num_restricoes-1][index]=indices[index];
			pDoc->matriz_a[pDoc->num_restricoes-1][pDoc->num_variaveis+pDoc->num_excesso-1]=-1;
			pDoc->matriz_a[pDoc->num_restricoes-1][pDoc->num_variaveis+pDoc->num_excesso+pDoc->num_artificiais-1]=1;

			pDoc->vetor_i[pDoc->num_restricoes-1]=pDoc->num_variaveis+pDoc->num_excesso+pDoc->num_artificiais-1;
			frac=modf(pDoc->vetor_b[linha],&inteira);
			if (frac<0)
				frac+=1;
			pDoc->vetor_b[pDoc->num_restricoes-1]=(float)frac;
			
		//prxima iterao
		free(indices);
		}
		
		count++;
	} while (count<MAX_ITE && !respostas_inteiras);
	//Verifica convergncia
	if (!respostas_inteiras) {
		//No convergiu
		pDoc->status=4;
	}
}
